
public class MergeSort
{
    /**
     * List1 & list2 are already sorted
     * 
     * @param list1
     * @param list2
     * @return
     */
    public static int[] merge(int[] list1, int[] list2)
    {
       int[] out = new int[list1.length + list2.length];
       
       int i1 = 0;
       int i2 = 0;
       int iOut = 0;
       
       // Copy while there are items in both lists
       while(i1 < list1.length && i2 < list2.length)
       {
           if (list1[i1] < list2[i2])
           {
               out[iOut] = list1[i1];
               ++i1;
               ++iOut;
           }else{
               out[iOut] = list2[i2];
               ++i2;
               ++iOut;
           }
       }
       // Copy the remainder
       while(i1 < list1.length)
       {
           out[iOut] = list1[i1];
           ++i1;
           ++iOut;
       }
       
       while(i2 < list2.length)
       {
           out[iOut] = list2[i2];
           ++i2;
           ++iOut;
       }
       
       return out;
       
    }
    
    public static int[] sort(int[] list)
    {
        // Base case
        if(list.length <= 1)
        {
            return list;
        }
        
        // Recursive case
        int[] list1 = new int[list.length/2];
        int[] list2 = new int[list.length - list.length/2];
        
        // Copy elements
        for(int i = 0; i < list1.length; ++i)
        {
            list1[i] = list[i];
            list2[i] = list[i + list.length/2];
            
        }
        // Copy last element to end of list 2
        list2[list2.length - 1] = list[list.length - 1];
        
        return merge(sort(list1), sort(list2));
    }
    
    public static void displayList(int[] list)
    {
        for(int i: list)
        {
            System.out.print(i + " ");
        }
        System.out.println("");
    }
    /**
     * @param args
     */
    public static void main(String[] args)
    {
        int[] list = {42, 2332, 3, 98, 273, 22, 1983, 3};
        
        displayList(list);
        displayList(sort(list));
    }

}
